$fs=0.1;
$fa=1;
e = 0.01;

overall_w = 54;
overall_l = 47.8;
overall_h = 7.5;
tab_w = 12.4;
tab_l = 1.4;
tab_h = 1.5;
relief_l = 12;
flex_th = 0.8;

difference() {
    union() {
        difference() {
            union() {
                translate([2, 0, 0])
                    cube([49.8, 45.8, 7.5]);
                translate([0, 0, 1.6])
                    cube([overall_w, overall_l, 5.9]);
                // tabs at top edge
                difference() {
                    translate([0, 0, overall_h-e]) {
                        cube([tab_w, tab_l, tab_h+e]);
                        translate([overall_w-tab_w, 0, 0])
                            cube([tab_w, tab_l, tab_h+e]);
                    }
                    translate([tab_w, -e, overall_h+tab_h]) rotate([-90, 0, 0])
                        cylinder(r=tab_h, h=tab_l+2*e);
                    translate([overall_w-tab_w, -e, overall_h+tab_h]) rotate([-90, 0, 0])
                        cylinder(r=tab_h, h=tab_l+2*e);
                }
                // latches on sides
                translate([0, 4.7, 4.5+.4]) {
                    translate([1, 3, 0])
                        cylinder(r=1.5, h=2.6);
                    translate([overall_w - 1, 3, 0])
                        cylinder(r=1.5, h=2.6);
                }
            }
            // printability cuts
            translate([2, -e, 1.6]) rotate([0, -135, 0])
                cube([3, overall_l + 2*e, 3]);
            translate([overall_w-2, -e, 1.6]) rotate([0, 45, 0])
                cube([3, overall_l + 2*e, 3]);
            translate([-e, 45.8, 1.6]) rotate([-45, 0, 0])
                cube([overall_w + 2*e, 5, 5]);
        }
        // angled bits on front
        translate([2+e, 0, 0]) linear_extrude(height=3) polygon([
            [0, 0], [-1, 0], [0, 8]
        ]);
        translate([51.8-e, 0, 0]) linear_extrude(height=3) polygon([
            [0, 0], [1, 0], [0, 8]
        ]);
    }
    // draft angle on top edge
    translate([-e, 0, overall_h+tab_h]) rotate([183, 0, 0])
        cube([overall_w+2*e, 2, overall_h+tab_h+1]);
    // relief cuts for latches
    translate([flex_th, 1.4, overall_h - 4])
        cube([1, relief_l, 4+e]);
    translate([-e, 1.4, overall_h - 4])
        cube([1+flex_th+e, relief_l, 1]);
    translate([overall_w - flex_th - 1, 1.4, overall_h - 4])
        cube([1, relief_l, 4+e]);
    translate([overall_w - 1 - flex_th + e, 1.4, overall_h - 4])
        cube([1+flex_th+e, relief_l, 1]);
    // printability cuts
    translate([0, 6.2, overall_h-2.6]) rotate([0, -135, 0])
        cube([1, 3, 1]);
    translate([overall_w, 6.2, overall_h-2.6]) rotate([0, 45, 0])
        cube([1, 3, 1]);
    // grip thingy on front
    translate([(overall_w-25)/2, 2, -e]) intersection() {
        for(i = [0:6]) {
            translate([0, 1.5*i, ])
                cube([25, 0.8, 0.4+e]);
        }
        translate([12.5, 12.5, 0]) cylinder(d=25, h=0.4+e);
    }
}